/*
 * server.c :  server [ asteapta ca un client sa porneasca ]
 * IPC - SO - Laborator 5
 */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <errno.h>
#include <unistd.h>
#include <semaphore.h>
#include <fcntl.h>
#include <sys/types.h>

#include "util.h"


int main(void)
{
	sem_t *s;
	int status;
	time_t current_time;

	/* TODO - deschide semaforul */
	s = sem_open(SEM_NAME, 0);
	CHECK(s != SEM_FAILED);

	/* TODO - se astepta neblocant semaforul
	   cat timp semaforul e blocat se afiseaza mesajul */
	while (1) {
		status = sem_trywait(s);
		if (status == 0)
			break;

		if (errno == EAGAIN) {
			time(&current_time);
			printf("Client time: %s\n", ctime(&current_time));
			sleep(1);
			continue;
		}

		perror("sem_trywait");
		exit(EXIT_FAILURE);
	}

	/* TODO - inchide semaforul */
	CHECK(sem_close(s) >= 0);

	/* TODO - sterge semaforul */
	CHECK(sem_unlink(SEM_NAME) >= 0);

	return 0;
}
