/**
 * 3. Server pentru memoria partajata
 * SO - Laborator 5 - IPC
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include <sys/mman.h>
#include <sys/types.h>
#include <fcntl.h>

#include "util.h"


int main(void)
{
	void *mem;	/* adresa de mapare */
	int shm_fd;	/* descriptor zona de memorie */

	/* TODO - creeaza zona de memorie partajata */
	shm_fd = shm_open(SHM_NAME, O_CREAT | O_RDWR, 0644);

	/* TODO - redimensionarea zonei de memorie */
	CHECK(ftruncate(shm_fd, SHM_SIZE) >= 0);

	mem = mmap(0, SHM_SIZE, PROT_WRITE | PROT_READ, MAP_SHARED, shm_fd, 0);
	CHECK(mem != MAP_FAILED);

	((int*)mem)[0] = 2010;
	printf("Am scris: %d\n", ((int*)mem)[0]);

	/* TODO - demapeaza zona de memorie */
	CHECK(munmap(mem, SHM_SIZE) >= 0);

	/* TODO - inchide descriptorul zonei de memorie */
	CHECK(close(shm_fd) >= 0);

	sleep(10);

	/* TODO - sterge zona de memorie */
	CHECK(shm_unlink(SHM_NAME) >= 0);

	return 0;
}
