/**
 * 1. Implementare CLIENT
 * SO - Laborator 5 - IPC
 */

#include <windows.h>
#include <stdio.h>
#include <time.h>

#include "common.h"

HANDLE sem;
time_t current_time;
wchar_t buf[SIZE];
errno_t err;

int main()
{

	sem = OpenSemaphore(SEMAPHORE_ALL_ACCESS, FALSE, SEM_NAME);
	CHECK(sem != NULL);

	while (WaitForSingleObject(sem, 1000) == WAIT_TIMEOUT)
		printf("Semaphore still locked\n");

	time(&current_time);
    
	err = _wctime_s( buf, SIZE, &current_time );
	CHECK (err == 0);

	wprintf(L"Client time: %s\n", buf);

	CHECK(CloseHandle(sem) != 0);

    return 0;
}
