/*
 * client.c : client [ determina deblocarea serverului ]
 * IPC - SO - Laborator 5
 */

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <time.h>
#include <unistd.h>
#include <sys/types.h>
#include <semaphore.h>

#include "util.h"


int main(void)
{
	sem_t* s;
	time_t current_time;

	/* TODO - creeaza un semafor cu valoarea initiala setata la 1 */
	s = sem_open(SEM_NAME, O_CREAT, 0644, 1);
	CHECK(s != SEM_FAILED);

	/* TODO - decrementeaza semaforul folosind o functie blocanta */
	CHECK(sem_wait(s) >= 0);

	time(&current_time);
	printf("Server time: %s\n", ctime(&current_time));

	sleep(5);

	/* TODO - incrementeaza semaforul */
	CHECK(sem_post(s) >= 0);

	/* TODO - inchide semaforul */
	CHECK(sem_close(s) >= 0);

	return 0;
}
