/**
 * 3. Client pentru memoria partajata
 * SO - Laborator 5 - IPC
 */

#include <stdio.h>
#include <stdlib.h>

#include <unistd.h>
#include <sys/mman.h>
#include <sys/types.h>
#include <fcntl.h>

#include "util.h"


int main(void)
{
	void *mem;	/* adresa de mapare */
	int shm_fd;	/* descriptor zona de memorie */

	/* TODO - deschide zona de memorie */
	shm_fd = shm_open(SHM_NAME, O_RDWR, 0644);
	CHECK(shm_fd >= 0);

	/* mapeaza zona de memorie */
	mem = mmap(0, SHM_SIZE, PROT_READ | PROT_WRITE, MAP_SHARED, shm_fd, 0);
	CHECK(mem != MAP_FAILED);

	printf("Am primit de la server: %d\n", * ((int *) mem));

	/* TODO demapare zona de memorie */
	CHECK(munmap(mem, SHM_SIZE) >= 0);

	/* TODO inchide descriptorul zonei de memorie */
	CHECK(close(shm_fd) >= 0);

	return 0;
}
