/**
 * 1. Implementare SENDER
 * SO - Laborator 5 - IPC
 */

#include <windows.h>
#include <stdio.h>
#include <time.h>

#include "common.h"

HANDLE sem;
time_t current_time;
wchar_t buf[SIZE];
errno_t err;

int main()
{

	sem = CreateSemaphore(NULL, 1, 9999, SEM_NAME);    
	CHECK(sem != NULL);

	CHECK(WaitForSingleObject(sem, INFINITE) != WAIT_FAILED);

	time(&current_time);
    
	err = _wctime_s( buf, SIZE, &current_time );
	CHECK (err == 0);

	wprintf(L"Server time: %s\n", buf);

	Sleep(5000);

	CHECK(ReleaseSemaphore(sem, 1, NULL) != 0);

	CHECK(CloseHandle(sem) != 0);

    return 0;
}
